//----------------------------------------------------------------------------
// CY8C29466TvvO
// AN2298Example1̃zXgAvP[V𗘗p
//	P2.2`P2.5FLEDڑi'0'œ_j
//	P3.2`P3.5FXCb`́i'0'ONj
//	P0.5FgóiLEDf[^Ŏgωj
//----------------------------------------------------------------------------

#include <m8c.h>        // part specific constants and macros
#include "PSoCAPI.h"    // PSoC API definitions for all User Modules


//
//int(24e6/200/f+0.5)-1;
//
unsigned char tone[16] = {
228,	// h	523.251131	524.017467	0.001465
203,	// 	587.329536	588.235294	0.001542
181,	// ~	659.255114	659.340659	0.000130
171,	// t@	698.456463	697.674419	-0.001120
152,	// \	783.990872	784.313725	0.000412
135,	// 	880.000000	882.352941	0.002674
120,	// V	987.766603	991.735537	0.004018
114,	// h	1046.502261	1043.478261	-0.002890
101,	// 	1174.659072	1176.470588	0.001542
90,	// ~	1318.510228	1318.681319	0.000130
85,	// t@	1396.912926	1395.348837	-0.001120
76,	// \	1567.981744	1558.441558	-0.006084
67,	// 	1760.000000	1764.705882	0.002674
60,	// V	1975.533205	1967.213115	-0.004212
56,	// h	2093.004522	2105.263158	0.005857
50	// 	2349.318143	2352.941176	0.001542
};

extern unsigned char USB_INTERFACE_0_OUT_RPT_DATA[8];
unsigned char switch_data;
unsigned char led_data;
unsigned char nled_data;

//--------------------------------------------------------
//-- LEDo						--
//-- P3.2`3.5ɐڑ					--
//-- '0'œ_A'1'ŏ̂ŁAf[^𔽓]	--
//--------------------------------------------------------
void set_led(unsigned char leddat)
{
	PRT3DR = ((leddat ^ 0xf) << 2) | 0xc3;
}

//----------------------------------------------------------------
//-- XCb`Ǎ						--
//-- P2.2`2.5ɐڑ						--
//-- vAbv͂ɂāAON'0'ɂȂ̂ŁAf[^𔽓]	--
//----------------------------------------------------------------
unsigned char get_sw(void)
{
	return((PRT2DR >> 2) ^ 0xf) & 0xf;
}

//----------------------------------------------------------------
//-- Set Configuration҂					--
//-- 0ȊO̒liۂɂ1ŗ锤jɂȂ瓮Jn		--
//-- OɃf[^ZbgĂAoXZbg	--
//-- NAĂ܂Ƃ̂ŁAK҂		--
//----------------------------------------------------------------
void wait_wakeup()
{
	while (!USB_bGetConfiguration())
		;
}

//----------------------------------------------------------------
//-- eW[̓X^[g					--
//----------------------------------------------------------------
void start_modules(void)
{
	USB_Start(0, USB_5V_OPERATION);	// USBX^[g
	Timer8_1_WritePeriod(tone[led_data & 0xf]);
	Timer8_1_Start();
	PWM8_1_Start();
	PGA_1_Start(PGA_1_HIGHPOWER);
	BPF2_1_Start(BPF2_1_HIGHPOWER);
	BPF2_2_Start(BPF2_1_HIGHPOWER);
}

//----------------------------------------------------------------
//-- C							--
//-- 1)XCb`ĂEP1ɓn				--
//-- 2)SET_REPORTNGXgŎ󂯂f[^LEDɃZbg	--
//--								--
//-- WindowsHIDfoCXWriteFile			--
//--  EInterrupt-OUTGh|CgInterrupt-OUTɑ	--
//--  EInterrupt-OUTȂEP0gSET_REPORTő	--
//----------------------------------------------------------------
void main()
{
	while(1) {
		PRT2DR = 0xff;				// vAbvCl[u
		led_data = 0x00;			// LED͂Ƃ肠
		set_led(led_data);
		M8C_EnableGInt;				// CPU݃Cl[u
		start_modules();			// eW[Jn
		wait_wakeup();				// Configuration҂
		switch_data = get_sw();			// XCb`f[^
		USB_LoadInEP(1, &switch_data, 1, USB_TOGGLE);	// ŏ̃XCb`f[^Zbg
		while (USB_bGetConfiguration()) {	// 쒆0ȊO
			if (USB_bGetEPAckState(1)) {	// EP1(INT-IN)ACKԂĂ
				switch_data = get_sw();	// VKf[^Zbg
				USB_LoadInEP(1, &switch_data, 1, USB_TOGGLE);
			}
			nled_data = USB_INTERFACE_0_OUT_RPT_DATA[0];	// zXgSET_REPORTNGXgf[^
			if (nled_data != led_data) {	// ω
				led_data = nled_data;	// ωOf[^XV
				set_led(led_data);	// LEDԕύX
				Timer8_1_WritePeriod(tone[led_data & 0xf]);	// gf[^Zbg
			}
		}
		USB_Stop();		// 0ԂConfigurationꂽ瓮~
	}
}
